/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.TiposensorRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Tiposensor extends TableImpl<TiposensorRecord> {

    private static final long serialVersionUID = 746442730;

    /**
     * The reference instance of <code>public.tiposensor</code>
     */
    public static final Tiposensor TIPOSENSOR = new Tiposensor();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TiposensorRecord> getRecordType() {
        return TiposensorRecord.class;
    }

    /**
     * The column <code>public.tiposensor.tipsenid</code>.
     */
    public final TableField<TiposensorRecord, Integer> TIPSENID = createField("tipsenid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('tiposensor_tipsenid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.tiposensor.tipsennome</code>.
     */
    public final TableField<TiposensorRecord, String> TIPSENNOME = createField("tipsennome", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.tiposensor.tipsendescricao</code>.
     */
    public final TableField<TiposensorRecord, String> TIPSENDESCRICAO = createField("tipsendescricao", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * Create a <code>public.tiposensor</code> table reference
     */
    public Tiposensor() {
        this(DSL.name("tiposensor"), null);
    }

    /**
     * Create an aliased <code>public.tiposensor</code> table reference
     */
    public Tiposensor(String alias) {
        this(DSL.name(alias), TIPOSENSOR);
    }

    /**
     * Create an aliased <code>public.tiposensor</code> table reference
     */
    public Tiposensor(Name alias) {
        this(alias, TIPOSENSOR);
    }

    private Tiposensor(Name alias, Table<TiposensorRecord> aliased) {
        this(alias, aliased, null);
    }

    private Tiposensor(Name alias, Table<TiposensorRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.TIPOSENSOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<TiposensorRecord, Integer> getIdentity() {
        return Keys.IDENTITY_TIPOSENSOR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<TiposensorRecord> getPrimaryKey() {
        return Keys.TIPOSENSOR_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<TiposensorRecord>> getKeys() {
        return Arrays.<UniqueKey<TiposensorRecord>>asList(Keys.TIPOSENSOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Tiposensor as(String alias) {
        return new Tiposensor(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Tiposensor as(Name alias) {
        return new Tiposensor(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Tiposensor rename(String name) {
        return new Tiposensor(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Tiposensor rename(Name name) {
        return new Tiposensor(name, null);
    }
}
